org.icefaces.ace.component.combobox

## Class ComboBoxBase

- java.lang.Object
- - javax.faces.component.UIComponent
  - - javax.faces.component.UIComponentBase
    - - javax.faces.component.UIOutput
      - - javax.faces.component.UIInput
        - - javax.faces.component.html.HtmlInputText
          - - org.icefaces.ace.component.combobox.ComboBoxBase

- All Implemented Interfaces:
    java.util.EventListener, javax.faces.component.behavior.ClientBehaviorHolder, javax.faces.component.EditableValueHolder, javax.faces.component.PartialStateHolder, javax.faces.component.StateHolder, javax.faces.component.TransientStateHolder, javax.faces.component.ValueHolder, javax.faces.event.ComponentSystemEventListener, javax.faces.event.FacesListener, javax.faces.event.SystemEventListenerHolder, IceClientBehaviorHolder, IComboBox
  Direct Known Subclasses:
    ComboBox

      public abstract class ComboBoxBase
      extends javax.faces.component.html.HtmlInputText
      implements IComboBox, IceClientBehaviorHolder

  A component that merges a select and an input field.

  For more information, see the ComboBox Wiki Documentation.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `ComboBoxBase.PropertyKeys`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `COMPONENT_TYPE`
    `static java.lang.String` | `RENDERER_TYPE`

    - ### Fields inherited from class javax.faces.component.UIInput

      `COMPONENT_FAMILY, CONVERSION_MESSAGE_ID, REQUIRED_MESSAGE_ID, UPDATE_MESSAGE_ID, VALIDATE_EMPTY_FIELDS_PARAM_NAME`

    - ### Fields inherited from class javax.faces.component.UIComponent

      `ATTRS_WITH_DECLARED_DEFAULT_VALUES, BEANINFO_KEY, bindings, COMPOSITE_COMPONENT_TYPE_KEY, COMPOSITE_FACET_NAME, CURRENT_COMPONENT, CURRENT_COMPOSITE_COMPONENT, FACETS_KEY, HONOR_CURRENT_COMPONENT_ATTRIBUTES_PARAM_NAME, VIEW_LOCATION_KEY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ComboBoxBase()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addClientBehavior(java.lang.String eventName, javax.faces.component.behavior.ClientBehavior behavior)`
    `java.lang.String` | `getDefaultEventName()`
    `java.lang.String` | `getDefaultExecute(java.lang.String event)`
    `java.lang.String` | `getDefaultRender(java.lang.String event)`
    `int` | `getDelay()` Return the value of the `delay` property.
    `java.util.Collection<java.lang.String>` | `getEventNames()`
    `java.lang.String` | `getFamily()`
    `java.lang.String` | `getFilterMatchMode()` Return the value of the `filterMatchMode` property.
    `int` | `getHeight()` Return the value of the `height` property.
    `java.lang.String` | `getHideEffect()` Return the value of the `hideEffect` property.
    `int` | `getHideEffectLength()` Return the value of the `hideEffectLength` property.
    `java.lang.String` | `getIndicatorPosition()` Return the value of the `indicatorPosition` property.
    `java.lang.Object` | `getItemDisabled()` Return the value of the `itemDisabled` property.
    `java.util.List` | `getItemList()` Return the value of the `itemList` property.
    `java.lang.Object` | `getItemValue()` Return the value of the `itemValue` property.
    `java.lang.String` | `getLabelPosition()` Return the value of the `labelPosition` property.
    `java.lang.String` | `getListenerArgument(java.lang.String event)`
    `java.util.List` | `getListValue()` Return the value of the `listValue` property.
    `java.lang.String` | `getListVar()` Return the value of the `listVar` property.
    `int` | `getMinChars()` Return the value of the `minChars` property.
    `java.lang.String` | `getOptionalIndicator()` Return the value of the `optionalIndicator` property.
    `java.lang.String` | `getRequiredIndicator()` Return the value of the `requiredIndicator` property.
    `int` | `getRows()` Return the value of the `rows` property.
    `java.lang.String` | `getShowEffect()` Return the value of the `showEffect` property.
    `int` | `getShowEffectLength()` Return the value of the `showEffectLength` property.
    `int` | `getWidth()` Return the value of the `width` property.
    `boolean` | `isCaseSensitive()` Return the value of the `caseSensitive` property.
    `protected boolean` | `isPropertySet(java.lang.String finder)`
    `boolean` | `isShowListOnInput()` Return the value of the `showListOnInput` property.
    `void` | `setCaseSensitive(boolean caseSensitive)` Set the value of the `caseSensitive` property.
    `void` | `setDelay(int delay)` Set the value of the `delay` property.
    `void` | `setFilterMatchMode(java.lang.String filterMatchMode)` Set the value of the `filterMatchMode` property.
    `void` | `setHeight(int height)` Set the value of the `height` property.
    `void` | `setHideEffect(java.lang.String hideEffect)` Set the value of the `hideEffect` property.
    `void` | `setHideEffectLength(int hideEffectLength)` Set the value of the `hideEffectLength` property.
    `void` | `setIndicatorPosition(java.lang.String indicatorPosition)` Set the value of the `indicatorPosition` property.
    `void` | `setItemDisabled(java.lang.Object itemDisabled)` Set the value of the `itemDisabled` property.
    `void` | `setItemList(java.util.List itemList)` Set the value of the `itemList` property.
    `void` | `setItemValue(java.lang.Object itemValue)` Set the value of the `itemValue` property.
    `void` | `setLabelPosition(java.lang.String labelPosition)` Set the value of the `labelPosition` property.
    `void` | `setListValue(java.util.List listValue)` Set the value of the `listValue` property.
    `void` | `setListVar(java.lang.String listVar)` Set the value of the `listVar` property.
    `void` | `setMinChars(int minChars)` Set the value of the `minChars` property.
    `void` | `setOptionalIndicator(java.lang.String optionalIndicator)` Set the value of the `optionalIndicator` property.
    `void` | `setRequiredIndicator(java.lang.String requiredIndicator)` Set the value of the `requiredIndicator` property.
    `void` | `setRows(int rows)` Set the value of the `rows` property.
    `void` | `setShowEffect(java.lang.String showEffect)` Set the value of the `showEffect` property.
    `void` | `setShowEffectLength(int showEffectLength)` Set the value of the `showEffectLength` property.
    `void` | `setShowListOnInput(boolean showListOnInput)` Set the value of the `showListOnInput` property.
    `void` | `setValueExpression(java.lang.String name, javax.el.ValueExpression binding)`
    `void` | `setWidth(int width)` Set the value of the `width` property.

    - ### Methods inherited from class javax.faces.component.html.HtmlInputText

      `getAccesskey, getAlt, getAutocomplete, getDir, getLabel, getLang, getMaxlength, getOnblur, getOnchange, getOnclick, getOndblclick, getOnfocus, getOnkeydown, getOnkeypress, getOnkeyup, getOnmousedown, getOnmousemove, getOnmouseout, getOnmouseover, getOnmouseup, getOnselect, getSize, getStyle, getStyleClass, getTabindex, getTitle, isDisabled, isReadonly, setAccesskey, setAlt, setAutocomplete, setDir, setDisabled, setLabel, setLang, setMaxlength, setOnblur, setOnchange, setOnclick, setOndblclick, setOnfocus, setOnkeydown, setOnkeypress, setOnkeyup, setOnmousedown, setOnmousemove, setOnmouseout, setOnmouseover, setOnmouseup, setOnselect, setReadonly, setSize, setStyle, setStyleClass, setTabindex, setTitle`

    - ### Methods inherited from class javax.faces.component.UIInput

      `addValidator, addValueChangeListener, clearInitialState, compareValues, decode, getConvertedValue, getConverterMessage, getRequiredMessage, getSubmittedValue, getValidator, getValidatorMessage, getValidators, getValue, getValueChangeListener, getValueChangeListeners, isEmpty, isImmediate, isLocalValueSet, isRequired, isValid, markInitialState, processDecodes, processUpdates, processValidators, removeValidator, removeValueChangeListener, resetValue, restoreState, saveState, setConverterMessage, setImmediate, setLocalValueSet, setRequired, setRequiredMessage, setSubmittedValue, setValid, setValidator, setValidatorMessage, setValue, setValueChangeListener, updateModel, validate, validateValue`

    - ### Methods inherited from class javax.faces.component.UIOutput

      `getConverter, getLocalValue, setConverter`

    - ### Methods inherited from class javax.faces.component.UIComponentBase

      `addFacesListener, broadcast, encodeBegin, encodeChildren, encodeEnd, findComponent, getAttributes, getChildCount, getChildren, getClientBehaviors, getClientId, getFacesContext, getFacesListeners, getFacet, getFacetCount, getFacets, getFacetsAndChildren, getId, getListenersForEventClass, getParent, getRenderer, getRendererType, getRendersChildren, getValueBinding, invokeOnComponent, isRendered, isTransient, processRestoreState, processSaveState, queueEvent, removeFacesListener, restoreAttachedState, saveAttachedState, setId, setParent, setRendered, setRendererType, setTransient, setValueBinding, subscribeToEvent, unsubscribeFromEvent`

    - ### Methods inherited from class javax.faces.component.UIComponent

      `encodeAll, getClientId, getCompositeComponentParent, getContainerClientId, getCurrentComponent, getCurrentCompositeComponent, getNamingContainer, getResourceBundleMap, getStateHelper, getStateHelper, getTransientStateHelper, getTransientStateHelper, getValueExpression, initialStateMarked, isCompositeComponent, isInView, isVisitable, popComponentFromEL, processEvent, pushComponentToEL, restoreTransientState, saveTransientState, setInView, visitTree`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.faces.component.behavior.ClientBehaviorHolder

      `getClientBehaviors`

    - ### Methods inherited from interface javax.faces.component.ValueHolder

      `getConverter, getLocalValue, setConverter`

- - ### Field Detail

    - #### COMPONENT_TYPE

          public static final java.lang.String COMPONENT_TYPE

      See Also:
        Constant Field Values

    - #### RENDERER_TYPE

          public static final java.lang.String RENDERER_TYPE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ComboBoxBase

          public ComboBoxBase()

  - ### Method Detail

    - #### getFamily

          public java.lang.String getFamily()

      Overrides:
        `getFamily` in class `javax.faces.component.UIInput`

    - #### setCaseSensitive

          public void setCaseSensitive(boolean caseSensitive)

      Set the value of the `caseSensitive` property.

      Contents: Boolean value that indicates whether the filtering should be case sensitive or not.

      Specified by:
        `setCaseSensitive` in interface `IComboBox`

    - #### isCaseSensitive

          public boolean isCaseSensitive()

      Return the value of the `caseSensitive` property.

      Contents: Boolean value that indicates whether the filtering should be case sensitive or not. Default = 'false'.

      Specified by:
        `isCaseSensitive` in interface `IComboBox`

    - #### setDelay

          public void setDelay(int delay)

      Set the value of the `delay` property.

      Contents: Delay in milliseconds for showing the list of possible matches after typing a character.

      Specified by:
        `setDelay` in interface `IComboBox`

    - #### getDelay

          public int getDelay()

      Return the value of the `delay` property.

      Contents: Delay in milliseconds for showing the list of possible matches after typing a character. Default = '400'.

      Specified by:
        `getDelay` in interface `IComboBox`

    - #### setFilterMatchMode

          public void setFilterMatchMode(java.lang.String filterMatchMode)

      Set the value of the `filterMatchMode` property.

      Contents: Defines the method of filter comparison used. Types available include: "contains", "exact", "startsWith", "endsWith" and "none".

      Specified by:
        `setFilterMatchMode` in interface `IComboBox`

    - #### getFilterMatchMode

          public java.lang.String getFilterMatchMode()

      Return the value of the `filterMatchMode` property.

      Contents: Defines the method of filter comparison used. Types available include: "contains", "exact", "startsWith", "endsWith" and "none". Default = 'none'.

      Specified by:
        `getFilterMatchMode` in interface `IComboBox`

    - #### setHeight

          public void setHeight(int height)

      Set the value of the `height` property.

      Contents: Maximum height in pixels of the list of possible matches (if 0, then the size is automatically adjusted to show all possible matches).

      Specified by:
        `setHeight` in interface `IComboBox`

    - #### getHeight

          public int getHeight()

      Return the value of the `height` property.

      Contents: Maximum height in pixels of the list of possible matches (if 0, then the size is automatically adjusted to show all possible matches). Default = '200'.

      Specified by:
        `getHeight` in interface `IComboBox`

    - #### setHideEffect

          public void setHideEffect(java.lang.String hideEffect)

      Set the value of the `hideEffect` property.

      Contents: Effect to use when hiding the list. Possible values are 'blind', 'bounce', 'clip', 'drop', 'explode', 'fade', 'fold', 'puff', 'pulsate', 'scale', and 'slide'.

      Specified by:
        `setHideEffect` in interface `IComboBox`

    - #### getHideEffect

          public java.lang.String getHideEffect()

      Return the value of the `hideEffect` property.

      Contents: Effect to use when hiding the list. Possible values are 'blind', 'bounce', 'clip', 'drop', 'explode', 'fade', 'fold', 'puff', 'pulsate', 'scale', and 'slide'. Default = 'fade'.

      Specified by:
        `getHideEffect` in interface `IComboBox`

    - #### setHideEffectLength

          public void setHideEffectLength(int hideEffectLength)

      Set the value of the `hideEffectLength` property.

      Contents: Length of time in milliseconds the hide effect will last for.

      Specified by:
        `setHideEffectLength` in interface `IComboBox`

    - #### getHideEffectLength

          public int getHideEffectLength()

      Return the value of the `hideEffectLength` property.

      Contents: Length of time in milliseconds the hide effect will last for. Default = '150'.

      Specified by:
        `getHideEffectLength` in interface `IComboBox`

    - #### setIndicatorPosition

          public void setIndicatorPosition(java.lang.String indicatorPosition)

      Set the value of the `indicatorPosition` property.

      Contents: Position of input-required or input-optional indicator relative to input field or label. Supported values are "left/right/top/bottom/labelLeft/labelRight/none". Default is "labelRight" if labelPosition is "inField", "right" otherwise.

      Specified by:
        `setIndicatorPosition` in interface `IComboBox`

    - #### getIndicatorPosition

          public java.lang.String getIndicatorPosition()

      Return the value of the `indicatorPosition` property.

      Contents: Position of input-required or input-optional indicator relative to input field or label. Supported values are "left/right/top/bottom/labelLeft/labelRight/none". Default is "labelRight" if labelPosition is "inField", "right" otherwise.

      Specified by:
        `getIndicatorPosition` in interface `IComboBox`

    - #### setItemDisabled

          public void setItemDisabled(java.lang.Object itemDisabled)

      Set the value of the `itemDisabled` property.

      Contents: ValueExpression that specifies the property of the data object to use for checking whether the item should be disabled or not. It must evaluate to a boolean value. This only applies when listvar is used and the rendering is done by means of a facet. When using f:selectItem(s), the disabled property on that object/tag is used for the same effect.

      Specified by:
        `setItemDisabled` in interface `IComboBox`

    - #### getItemDisabled

          public java.lang.Object getItemDisabled()

      Return the value of the `itemDisabled` property.

      Contents: ValueExpression that specifies the property of the data object to use for checking whether the item should be disabled or not. It must evaluate to a boolean value. This only applies when listvar is used and the rendering is done by means of a facet. When using f:selectItem(s), the disabled property on that object/tag is used for the same effect.

      Specified by:
        `getItemDisabled` in interface `IComboBox`

    - #### setItemValue

          public void setItemValue(java.lang.Object itemValue)

      Set the value of the `itemValue` property.

      Contents: ValueExpression that specifies the property of the data object to use as the value of the item for this component if it gets selected. This only applies when listvar is used and the rendering is done by means of a facet.

      Specified by:
        `setItemValue` in interface `IComboBox`

    - #### getItemValue

          public java.lang.Object getItemValue()

      Return the value of the `itemValue` property.

      Contents: ValueExpression that specifies the property of the data object to use as the value of the item for this component if it gets selected. This only applies when listvar is used and the rendering is done by means of a facet.

      Specified by:
        `getItemValue` in interface `IComboBox`

    - #### setLabelPosition

          public void setLabelPosition(java.lang.String labelPosition)

      Set the value of the `labelPosition` property.

      Contents: Position of label relative to input field. Supported values are "left/right/top/bottom/inField/none". Default is "none".

      Specified by:
        `setLabelPosition` in interface `IComboBox`

    - #### getLabelPosition

          public java.lang.String getLabelPosition()

      Return the value of the `labelPosition` property.

      Contents: Position of label relative to input field. Supported values are "left/right/top/bottom/inField/none". Default is "none".

      Specified by:
        `getLabelPosition` in interface `IComboBox`

    - #### setListValue

          public void setListValue(java.util.List listValue)

      Set the value of the `listValue` property.

      Contents: When rendering via a facet, this attribute specifies the list of data objects that contains all possible options.

      Specified by:
        `setListValue` in interface `IComboBox`

    - #### getListValue

          public java.util.List getListValue()

      Return the value of the `listValue` property.

      Contents: When rendering via a facet, this attribute specifies the list of data objects that contains all possible options.

      Specified by:
        `getListValue` in interface `IComboBox`

    - #### setListVar

          public void setListVar(java.lang.String listVar)

      Set the value of the `listVar` property.

      Contents: Variable name to use for referencing each data object in the list when rendering via a facet.

      Specified by:
        `setListVar` in interface `IComboBox`

    - #### getListVar

          public java.lang.String getListVar()

      Return the value of the `listVar` property.

      Contents: Variable name to use for referencing each data object in the list when rendering via a facet.

      Specified by:
        `getListVar` in interface `IComboBox`

    - #### setMinChars

          public void setMinChars(int minChars)

      Set the value of the `minChars` property.

      Contents: Minimum number of characters that must be in the text field before submitting and before producing the list of possible matches.

      Specified by:
        `setMinChars` in interface `IComboBox`

    - #### getMinChars

          public int getMinChars()

      Return the value of the `minChars` property.

      Contents: Minimum number of characters that must be in the text field before submitting and before producing the list of possible matches. Default = '0'.

      Specified by:
        `getMinChars` in interface `IComboBox`

    - #### setOptionalIndicator

          public void setOptionalIndicator(java.lang.String optionalIndicator)

      Set the value of the `optionalIndicator` property.

      Contents: Indicator indicating that the user is NOT required to provide a submitted value for this input component.

      Specified by:
        `setOptionalIndicator` in interface `IComboBox`

    - #### getOptionalIndicator

          public java.lang.String getOptionalIndicator()

      Return the value of the `optionalIndicator` property.

      Contents: Indicator indicating that the user is NOT required to provide a submitted value for this input component.

      Specified by:
        `getOptionalIndicator` in interface `IComboBox`

    - #### setRequiredIndicator

          public void setRequiredIndicator(java.lang.String requiredIndicator)

      Set the value of the `requiredIndicator` property.

      Contents: Indicator indicating that the user is required to provide a submitted value for this input component.

      Specified by:
        `setRequiredIndicator` in interface `IComboBox`

    - #### getRequiredIndicator

          public java.lang.String getRequiredIndicator()

      Return the value of the `requiredIndicator` property.

      Contents: Indicator indicating that the user is required to provide a submitted value for this input component.

      Specified by:
        `getRequiredIndicator` in interface `IComboBox`

    - #### setRows

          public void setRows(int rows)

      Set the value of the `rows` property.

      Contents: The maximum number of possible options to show to the user (set to 0 to display all rows).

      Specified by:
        `setRows` in interface `IComboBox`

    - #### getRows

          public int getRows()

      Return the value of the `rows` property.

      Contents: The maximum number of possible options to show to the user (set to 0 to display all rows). Default = '0'.

      Specified by:
        `getRows` in interface `IComboBox`

    - #### setShowEffect

          public void setShowEffect(java.lang.String showEffect)

      Set the value of the `showEffect` property.

      Contents: Effect to use when showing the list. Possible values are 'blind', 'bounce', 'clip', 'drop', 'explode', 'fade', 'fold', 'puff', 'pulsate', 'scale', 'slide', and 'shake'.

      Specified by:
        `setShowEffect` in interface `IComboBox`

    - #### getShowEffect

          public java.lang.String getShowEffect()

      Return the value of the `showEffect` property.

      Contents: Effect to use when showing the list. Possible values are 'blind', 'bounce', 'clip', 'drop', 'explode', 'fade', 'fold', 'puff', 'pulsate', 'scale', 'slide', and 'shake'. Default = 'fade'.

      Specified by:
        `getShowEffect` in interface `IComboBox`

    - #### setShowEffectLength

          public void setShowEffectLength(int showEffectLength)

      Set the value of the `showEffectLength` property.

      Contents: Length of time in milliseconds the show effect will last for.

      Specified by:
        `setShowEffectLength` in interface `IComboBox`

    - #### getShowEffectLength

          public int getShowEffectLength()

      Return the value of the `showEffectLength` property.

      Contents: Length of time in milliseconds the show effect will last for. Default = '150'.

      Specified by:
        `getShowEffectLength` in interface `IComboBox`

    - #### setShowListOnInput

          public void setShowListOnInput(boolean showListOnInput)

      Set the value of the `showListOnInput` property.

      Contents: Boolean value that indicates whether the popup list should be displayed when typing in the text field or only when clicking the down arrow button.

      Specified by:
        `setShowListOnInput` in interface `IComboBox`

    - #### isShowListOnInput

          public boolean isShowListOnInput()

      Return the value of the `showListOnInput` property.

      Contents: Boolean value that indicates whether the popup list should be displayed when typing in the text field or only when clicking the down arrow button. Default = 'true'.

      Specified by:
        `isShowListOnInput` in interface `IComboBox`

    - #### setWidth

          public void setWidth(int width)

      Set the value of the `width` property.

      Contents: The width of the text input field, in pixels.

      Specified by:
        `setWidth` in interface `IComboBox`

    - #### getWidth

          public int getWidth()

      Return the value of the `width` property.

      Contents: The width of the text input field, in pixels. Default = '200'.

      Specified by:
        `getWidth` in interface `IComboBox`

    - #### setItemList

          public void setItemList(java.util.List itemList)

      Set the value of the `itemList` property.

      Specified by:
        `setItemList` in interface `IComboBox`

    - #### getItemList

          public java.util.List getItemList()

      Return the value of the `itemList` property.

      Specified by:
        `getItemList` in interface `IComboBox`

    - #### isPropertySet

          protected boolean isPropertySet(java.lang.String finder)

    - #### setValueExpression

          public void setValueExpression(java.lang.String name,
                                         javax.el.ValueExpression binding)

      Overrides:
        `setValueExpression` in class `javax.faces.component.UIComponent`

    - #### getEventNames

          public java.util.Collection<java.lang.String> getEventNames()

      Specified by:
        `getEventNames` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `getEventNames` in class `javax.faces.component.html.HtmlInputText`

    - #### getDefaultEventName

          public java.lang.String getDefaultEventName()

      Specified by:
        `getDefaultEventName` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `getDefaultEventName` in class `javax.faces.component.html.HtmlInputText`

    - #### getDefaultRender

          public java.lang.String getDefaultRender(java.lang.String event)

      Specified by:
        `getDefaultRender` in interface `IceClientBehaviorHolder`

    - #### getDefaultExecute

          public java.lang.String getDefaultExecute(java.lang.String event)

      Specified by:
        `getDefaultExecute` in interface `IceClientBehaviorHolder`

    - #### getListenerArgument

          public java.lang.String getListenerArgument(java.lang.String event)

      Specified by:
        `getListenerArgument` in interface `IceClientBehaviorHolder`

    - #### addClientBehavior

          public void addClientBehavior(java.lang.String eventName,
                                        javax.faces.component.behavior.ClientBehavior behavior)

      Specified by:
        `addClientBehavior` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `addClientBehavior` in class `javax.faces.component.UIComponentBase`

Copyright 2025 ICEsoft Technologies Canada, Corp. All Rights Reserved.